<?php
ini_set('display_errors', '1');
ini_set('display_startup_errors', '1');
error_reporting(E_ALL);
require('amazon-sp-api-retry.php');
require __DIR__ . '/vendor/autoload.php';
$client = new Google_Client();
$client->setScopes(['https://www.googleapis.com/auth/gmail.readonly','https://www.googleapis.com/auth/gmail.modify']);
$client->setApplicationName('My'); // I don’t think this matters
//************************************************************************************************************************************
// Either this code
$user_to_impersonate = 'info@d4dauto.com'; //very important
$client->setSubject($user_to_impersonate); //important
//***********************************************************************************************************************************
// Or this code – you don’t need both
$client->setConfig('subject',$user_to_impersonate); //either the above method, or this will work
//************************************************************************************************************************************
$client->setAuthConfig('read-tracking-code-gmail.json'); //this is the json file you downloaded earlier
$client->setAccessType('offline'); //not sure this is necessary for this type of call

$gmailService = new Google_Service_Gmail($client);
$from = ' info@b2sign.com';
//$from = ' dot4dotprint@gmail.com';
$unread_messages = listMessages($gmailService, 'me',$from); //using ‘me’ means using the subject set above

/*echo "<pre>";
print_r($unread_messages);
echo "</pre>";*/
//exit;

if(sizeof(@$unread_messages)>0)
{
	foreach ($unread_messages as $key => $message_id) 
	{
	    $message_details = getMessageDetails($gmailService,'me',$message_id);
		if($message_details['from']!='' && $message_details['subject']!='' && $message_details['body']!='')
		{
		    $update = updateAmazonTracking($message_details);
		    if($update == true)
		    {
		        markRead($gmailService,'me',$message_id,$client,true);    
		    }
		}
	}	
}
else
{
	echo "No unread messages info@b2sign.com";
}

$from = ' noreply@signs365.com';
$unread_messages = listMessages($gmailService, 'me',$from); //using ‘me’ means using the subject set above

if(sizeof(@$unread_messages)>0)
{
	foreach ($unread_messages as $key => $message_id) 
	{
	    $message_details = getMessageDetails($gmailService,'me',$message_id);
		if($message_details['from']!='' && $message_details['subject']!='' && $message_details['body']!='')
		{
		    $update = updateAmazonTracking($message_details);
		    if($update == true)
		    {
		        markRead($gmailService,'me',$message_id,$client,true);    
		    }
		}
	}	
}
else
{
	echo "No unread messages for noreply@signs365.com";
}

function updateAmazonTracking($email_data_arr)
{
    /*echo "<pre>";
    print_r($email_data_arr);
    echo "</pre>";*/
    $sp_api = new amazonmws_sp_api_retry();
    $accessToken = $sp_api->getAccessToken();
    $sellerOrderId = "";
    $trackingNumber = "";
    if(isset($email_data_arr['from']))
    {
        $from = trim($email_data_arr['from']);
        if($from=='B2Sign.com infob2signcom')
        {
            $subject = $email_data_arr['subject'];
            //echo $subject;
            if(strpos($subject,'has been shipped'))
            {
                $pos = strpos($subject,"Your Order ");
                $sellerOrderId = substr($subject,$pos+strlen('Your Order'),9);
                $sellerOrderId = trim($sellerOrderId);
            
                $body = $email_data_arr['body'];
                if(strpos($body,'Tracking#:') || strpos($body,'Tracking#'))
                {
                    $pos = strpos($body,"Tracking#:");
                    $trackingNumber = substr($body,$pos+strlen('Tracking#:'),15);
                    $trackingNumber = trim($trackingNumber);
                }
            }
        }
        if($from=='Signs365 noreplysigns365com')
        {
            $subject = $email_data_arr['subject'];
            if(strpos($subject,'has Shipped'))
            {
                $pos = strpos($subject,"Your Signs365 Order #");
                $sellerOrderId = substr($subject,$pos+strlen('Your Signs365 Order #'),13);
                $sellerOrderId = trim($sellerOrderId);
            
                $body = $email_data_arr['body'];
                if(strpos($body,'Your tracking number is '))
                {
                    $pos = strpos($body,"Your tracking number is ");
                    $trackingNumber = substr($body,$pos+strlen('Your tracking number is '),13);
                    $trackingNumber = trim($trackingNumber);
                }
            }
        }
        /*if($from=='Dot4Dot Print dot4dotprintgmailcom')
        {
            $subject = $email_data_arr['subject'];
            //echo $subject;
            if(strpos($subject,'has been shipped'))
            {
                $pos = strpos($subject,"Your Order ");
                $sellerOrderId = substr($subject,$pos+strlen('Your Order'),9);
                $sellerOrderId = trim($sellerOrderId);
            
                $body = $email_data_arr['body'];
                if(strpos($body,'Tracking#:') || strpos($body,'Tracking#'))
                {
                    $pos = strpos($body,"Tracking#:");
                    $trackingNumber = substr($body,$pos+strlen('Tracking#:'),15);
                    $trackingNumber = trim($trackingNumber);
                }
            }
        }*/
    }
    else
    {
        echo "From not set.";    
    }
    
    /*$sellerOrderId='165543033585';
    $trackingNumber = '712332242682';*/
    if($sellerOrderId!="" && $trackingNumber!="")
    {
        /*echo $sellerOrderId;
        echo "<br>";
        echo $trackingNumber;
        exit;*/
        $orders = $sp_api->getOrderBySellerOrderId($sellerOrderId);
        $AmazonOrderId = "";
        if(isset($orders['payload']['Orders']))
        {
            if(sizeof($orders['payload']['Orders'])>0)
            {
                foreach($orders['payload']['Orders'] as $key=>$order)
                {
                    $AmazonOrderId = $order['AmazonOrderId'];
                }
            }
        }
        $order_items = array();
        if($AmazonOrderId !="")
        {
            $res = $sp_api->createFeedDocument();
            $feedDocumentId = $res['feedDocumentId'];
            $url = $res['url'];
            $url = rawurlencode($url);
            echo $sp_api->uploadXmlStringToSpApi($url,$AmazonOrderId,$trackingNumber,$order_items);
            $feedDocumentId = rawurlencode($feedDocumentId);
            $result = $sp_api->createFeedDG($feedDocumentId);
            
            echo " <br>Fulfillment Response <br>";
            echo '<pre>';
            print_r($result);
            echo '</pre>';
            
            return true;
        }
        else
        {
            echo "Amazon Order ID is Empty";    
            return false;
        }
           
    }
    else
    {
        echo "Seller ID or Tracking number Empty.";
        return false;
    }
}


function watch($service)
{	
	$post = array('labelIds'=>array('INBOX'),'labelFilterAction'=>'include','topicName'=>'projects/golden-resolver-311616/topics/trackpod');
	$postBody = json_encode($post);
	$mods = new Google_Service_Gmail_WatchRequest();
	$mods->setLabelIds(['INBOX']);
	$mods->setLabelFilterAction('include');
	$mods->setTopicName('projects/golden-resolver-311616/topics/trackpod');
	$message = $service->users->watch('me',$mods);
	/*echo "<pre>";
	print_r($message);
	echo "</pre>";
	exit;*/
}


function markRead($service,$userId,$message_id,$client,$attachment)
{
	$mods = new Google_Service_Gmail_ModifyMessageRequest();
	if($attachment)
	{
		$mods->setAddLabelIds(['STARRED']);
		//$mods->setAddLabelIds(['READ']);
	}
	$mods->setRemoveLabelIds(['UNREAD']);
	$message = $service->users_messages->modify($userId, $message_id, $mods);
	/*echo "Mark Read <br>";
	echo $userId;
	echo "<br>";
	echo $message_id;
	echo "<br>";
	print_r($mods);
	echo "<br>";
	echo "<pre>";
	print_r($message);
	echo "</pre>";*/
	
	
}



function getAttachment($service,$userId,$message_id,$attachment_id)
{
	try 
	{
		$attachmentObj = $service->users_messages_attachments->get($userId,$message_id,$attachment_id);//,['format'=>'metadata', 'metadataHeaders'=>['From', 'Subject','Attachment']]
		$data = $attachmentObj->getData();
		$data = strtr($data, array('-' => '+', '_' => '/'));
		$myfile = fopen("order.xlsx", "w+");;
		fwrite($myfile, base64_decode($data));
		fclose($myfile);
		return true;
	} 
	catch (Exception $e) 
	{
		return false;
	}
}


function getMessageDetails($service, $userId,$message_id) 
{
	$pageToken = NULL;
	$messages = array();
	$opt_param = array();
	$success = true;
	$opt_param['q']='is:unread';  //this will get us only unread messages
	$opt_param['maxResults']=100; //this limits the amount of unread messages returned

	try 
	{
		$messagesResponse = $service->users_messages->get($userId,$message_id);//,['format'=>'metadata', 'metadataHeaders'=>['From', 'Subject','Attachment']]
		if ($messagesResponse->getPayload()) 
		{
            
            $message_payload_details = $messagesResponse->getPayload();//->getParts()
            /*
            echo "<pre>";
            print_r($message_payload_details);
            echo "</pre>";
            exit;*/
            
            
            $headers = $messagesResponse->getPayload()->getHeaders();
            $subject = preg_replace('/[^a-zA-Z0-9#\s]/', '',getHeader($headers, 'Subject'));
            $from = preg_replace('/[^a-zA-Z0-9#\s]/', '',getHeader($headers, 'From'));
            $body = base64_decode(str_replace(['-', '_'], ['+', '/'],$message_payload_details['parts'][0]['body']['data']));
            //$cleanedbody = str_replace(['-', '_'], ['+', '/'],$body);
            
            /*$subject = getHeader($headers, 'Subject');
            $from = getHeader($headers, 'From');
            $body = base64_decode($message_payload_details['parts'][0]['body']['data']);
            $cleanedbody = preg_replace('/[^a-zA-Z0-9#\s]/', '', $body);*/
            
            $return = array('from'=>$from,'subject'=>$subject,'body'=>$body);
            
            return $return;
            /*$payload_details = $messagesResponse->payload;
		    return $payload_details;*/
	    	/*if(isset($message_payload_details[1]))
			{
			    return $message_payload_details[1]['body']['attachmentId'];    
			}
			else
			{
			    return $payload_details->body->attachmentId;
			}*/
				
		}
	} 
	catch (Exception $e) 
	{
		return false;
	}
}

function getHeader($headers, $name) {
  foreach($headers as $header) {
    if($header['name'] == $name) {
      return $header['value'];
    }
  }
}

function listMessages($service, $userId,$from) 
{
	$pageToken = NULL;
	$messages = array();
	$opt_param = array();
	$success = true;
	//$opt_param['q']='from:info@b2sign.com from:noreply@signs365.com is:unread';  //this will get us only unread messages
	$opt_param['q']='is:unread'.$from;
	$opt_param['maxResults']=10; //this limits the amount of unread messages returned

	try 
	{
		$messagesResponse = $service->users_messages->listUsersMessages($userId, $opt_param);
		/*echo "<pre>";
		print_r($messagesResponse);
		exit;*/

		if ($messagesResponse->getMessages()) 
		{
			$messages = array_merge($messages, $messagesResponse->getMessages());
		}
	} 
	catch (Exception $e) 
	{
		echo '<h2>you don’t have email access</h2>';
		echo '<br />';
		echo $e;
		$success=false;
	}

	if ($success) 
	{
		$unread_msg_ids = array();
		foreach ($messages as $message) 
		{
			$unread_msg_ids[] = $message->getId();
			//print 'Message with ID: ' . $message->getId() . '<br/>';
			//$messageText = getMessage($service,$userId,$message->getId());
			//print $messageText['snippet'];
		}
		return $unread_msg_ids;
	}
}
?>
